<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:strip-space elements="*"/>
	<xsl:output method="html" indent="yes" encoding="utf-8"/>

	<xsl:template match="PAGED-LIST/LIST">
		<script type='text/javascript'>feedbackFields=null;</script>
		<div style="overflow:auto;width:100%;height:195px;">
			<table cellspacing="1" border="0" id="fieldsList">
				<xsl:apply-templates select="HEADER"/>
				<xsl:call-template name="ITEM-TEMPLATE">
					<xsl:with-param name="number">1</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="ITEM-TEMPLATE">
					<xsl:with-param name="number">2</xsl:with-param>
				</xsl:call-template>
			</table>
			<a name="listBottom"/>
		</div>
		<script src='/modules/Feedback/js/Fields.js?{$version}.{$build}' type='text/javascript'></script>
		<script type='text/javascript'>feedbackFields=new Modules_Feedback_Fields('<xsl:value-of select="$skinPath"/>','<xsl:value-of select="/SITEBUILDER-PAGE/JS-LOCALE/NEW-FIELD"/>','<xsl:value-of select="/SITEBUILDER-PAGE/JS-LOCALE/ONE-INCLUDED-REQUIRES"/>');</script>
		<script type='text/javascript' language="javascript">
			<xsl:comment>
				<xsl:apply-templates select="ITEM"/>
				feedbackFields.reBuildList();
			//</xsl:comment>
		</script>
	</xsl:template>

	<xsl:template match="PAGED-LIST/LIST/HEADER">
		<tr class="SBGridViewHeader" align="left" style="height:24px;white-space:nowrap;">
			<th style="width:30px;text-align:center">#</th>
			<th style="width:30px;text-align:center">
				<xsl:value-of select="/SITEBUILDER-PAGE/LOCALE/TITLE-STATUS"/>
			</th>
			<th style="width:30px;text-align:center">
				<xsl:value-of select="/SITEBUILDER-PAGE/LOCALE/TITLE-REQUIRED"/>
			</th>
			<th style="width:250px;text-align:center">
				<xsl:value-of select="/SITEBUILDER-PAGE/LOCALE/TITLE-NAME"/>
			</th>
			<th style="width:150px;text-align:center">
				<xsl:value-of select="/SITEBUILDER-PAGE/LOCALE/TITLE-TYPE"/>
			</th>
			<th style="width:20px;">&#160;</th>
			<th style="width:20px;">&#160;</th>
			<th style="width:20px;text-align:ceter;">
				<input type="checkbox" onclick="feedbackFields.selectAll(this.checked);" autocomplete="off"/>
			</th>
			<th>&#160;</th>
		</tr>
    </xsl:template>

    <xsl:template match="PAGED-LIST/LIST/ITEM">
    	feedbackFields.register('<xsl:value-of select="TITLE"/>','<xsl:value-of select="TYPE"/>',<xsl:value-of select="IS-INCLUDED"/>,<xsl:value-of select="IS-REQUIRED"/>);
    </xsl:template>
    
    <xsl:template name="ITEM-TEMPLATE">
    	<xsl:param name="number"/>
    	<xsl:variable name="class" select="$number mod 2"/>
    	<tr class="SB_List_Rrow_{$class}" style="display: none">
			<td style="text-align:center;">&#160;</td>
			<td style="text-align:center">&#160;</td>
			<td style="text-align:center">&#160;</td>
			<td style="text-align:center">
				<input type="text" autocomplete="off" style="width:150px;"/>
			</td>
			<td style="text-align:center">
				<xsl:apply-templates select="/SITEBUILDER-PAGE/VIEW-CONTENT/FEEDBACK-EDITOR/FIELD-TYPES"/>
			</td>
			<td class="SB_GridText" style="text-align:center; padding-left: 4px; padding-right: 4px;">&#160;</td>
			<td class="SB_GridText" style="text-align:center; padding-left: 4px; padding-right: 4px;">&#160;</td>
			<td style="text-align:center;">
				<input type="checkbox" autocomplete="off"/>
			</td>
			<th>&#160;</th>
		</tr>
    </xsl:template>

    <xsl:template match="FIELD-TYPES">
    	<select style="width:100px;">
    		<xsl:apply-templates select="FIELD-TYPE"/>
    	</select>
    </xsl:template>
    
    <xsl:template match="FIELD-TYPE">
    	<option value="{@CODE}">
    		<xsl:value-of select="@TITLE"/>
    	</option>
    </xsl:template>

</xsl:stylesheet>